﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
    
// Дополнительные пространства имен
using System.Data.OleDb;
using System.Data.Common;
using System.Collections;
    
namespace WinForms1
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
    
            // Отключаем кнопку 'Связать'
            btnDataBind.Enabled = false;
            // Отключить системную кнопку
            this.MaximizeBox = false;
        }
    
        // Создаем объект массива списков
        ArrayList dbRecordsList = new ArrayList();// Поле
    
        // Строка соединения с абсолютным путем к БД, определяемым сборкой
        String ConnectionString(String fileName)
        {
            string JetEngineString = @"Provider=Microsoft.Jet.OLEDB.4.0;"
                + "Jet OLEDB:Engine Type=5;Data Source=";
            string pathToFile = Application.StartupPath.ToString() + "\\Data\\";
            return JetEngineString + pathToFile + fileName.Trim() + ".mdb";
        }
    
        // Заполнение массива списков данными 
        private void btnPopulate_Click(object sender, EventArgs e)
        {
            // Создаем объект соединения
            OleDbConnection objConnection = 
                new OleDbConnection(ConnectionString("Northwind"));
    
            dbRecordsList.Clear();// Очищаем список (необязательно!)
    
            // После выполнения тела инструкции using освободится подключение
            using (objConnection)
            {
                // Создаем объект команды с последующими настройками
                OleDbCommand objCommand = new OleDbCommand();
                objCommand.CommandType = CommandType.Text;// Не обязательно, по умолчанию
                objCommand.CommandText = "SELECT * FROM Customers";
                objCommand.Connection = objConnection;
    
                // Или сразу одним конструктором
                //OleDbCommand objCommand = new OleDbCommand("SELECT * FROM Customers", objConnection);
    
                objConnection.Open();// Открываем соединение
    
                // Выполняем объект Command одним из его методов
                OleDbDataReader dataReader = 
                    objCommand.ExecuteReader(           // Заполнить набор данных
                    CommandBehavior.CloseConnection);   // Отработать и сразу закрыть соединение
    
                // Счетчик количества записей
                int recCount = 0;
                if (dataReader.HasRows)// Флаг поднят, если есть строки 
                {
                    // Перебрать все строки набора и добавить в коллекцию списка
                    foreach (DbDataRecord rec in dataReader)
                    {
                        dbRecordsList.Add(rec);
                        recCount++;// Не будем использовать, подсчитаем ниже командой
                    }
                }
    
                // Подсчитываем число записей в таблице
                objCommand = new OleDbCommand("SELECT COUNT(*) FROM Customers", objConnection);
                objConnection.Open();
                recCount = (int)objCommand.ExecuteScalar();
                objConnection.Close();
                lblRegCount.Text += recCount.ToString();
            }
    
            // Переключаем доступность кнопок
            btnPopulate.Enabled = false;
            btnDataBind.Enabled = true;
        }
    
        private void btnDataBind_Click(object sender, EventArgs e)
        {
            // Связываем список с элементом отображения
            myDataGrid.DataSource = dbRecordsList;
    
            btnDataBind.Enabled = false;// Отключаем кнопку
        }
    }
}
