﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
    
// Дополнительные пространства имен
using System.Data.OleDb;
using System.Data.Common;
using System.Collections;
    
namespace WinForms2
{
    public partial class Form1 : Form
    {
        // Создаем объект списка сотрудников
        ArrayList dbEmployeesList = new ArrayList();// Поле
    
        public Form1()
        {
            InitializeComponent();
    
            LoadEmployees();
            LoadCustomers();
        }
    
        // Строка соединения с абсолютным путем к БД, определяемым сборкой
        String ConnectionString(String fileName)
        {
            string JetEngineString = @"Provider=Microsoft.Jet.OLEDB.4.0;"
                + "Jet OLEDB:Engine Type=5;Data Source=";
            string pathToFile = Application.StartupPath.ToString() + "\\Data\\";
            return JetEngineString + pathToFile + fileName.Trim() + ".mdb";
        }
    
        // Заполнение раскрывающегося списка из БД
        void LoadEmployees()
        {
            // Создаем объект соединения
            OleDbConnection objConnection = 
                new OleDbConnection(ConnectionString("Northwind"));
            // Создаем объект команды
            OleDbCommand objCommand = new OleDbCommand(
                "SELECT EmployeeID, RTRIM(LastName) + ', ' + RTRIM(FirstName) AS FullName FROM Employees",
                objConnection);
    
            // Открываем соединение
            objConnection.Open();
            // Читаем в DbDataReader
            OleDbDataReader reader = objCommand.ExecuteReader();
            // Заполняем автономный список записей
            foreach (DbDataRecord rec in reader)
            {
                dbEmployeesList.Add(rec);
            }
            // Закрываем соединение
            objConnection.Close();
    
            // Связываем автономный список записей с ComboBox
            cbEmployees.BeginUpdate();
            cbEmployees.DataSource = dbEmployeesList;
            cbEmployees.DisplayMember = "FullName";
            cbEmployees.ValueMember = "EmployeeID";
            cbEmployees.EndUpdate();
            cbEmployees.SelectedIndex = 0;// Устанавливаем на первый элемент
        }
    
        private void cbEmployees_SelectedIndexChanged(object sender, EventArgs e)
        {
            LoadOrders();               // Выбираем информацию из таблицы Orders
    
            // Прореживаем список
            ArrayList tmpList = new ArrayList();
            for (int i = 0; i < ordersCustomerID.Count; i++)
            {
                object val = ordersCustomerID[i];
                if (tmpList.IndexOf(val) == -1)
                    tmpList.Add(val);
            }
            //ordersCustomerID = tmpList.Clone() as ArrayList;
            ordersCustomerID = tmpList; // Бросаем старый список
            ordersCustomerID.Sort(); // Сортируем список
    
            lstCustomers.Items.Clear(); // Чистим ListBox 
            // Отображаем список
            for (int i = 0; i < ordersCustomerID.Count; i++)
            {
                //lstCustomers.Items.Add(ordersCustomerID[i]);
                int index = customerID.IndexOf(ordersCustomerID[i]);
                lstCustomers.Items.Add(customerID[index] + "\t - " + companyName[index]);
            }
        }
    
        // Читаем таблицу заказчиков Customers
        ArrayList companyName = new ArrayList();
        ArrayList customerID = new ArrayList();
        void LoadCustomers()
        {
            OleDbConnection objConnection =
                new OleDbConnection(ConnectionString("Northwind"));
            OleDbCommand objCommand = new OleDbCommand(
                "SELECT CustomerID, CompanyName FROM Customers",
                objConnection);
            objConnection.Open();
            OleDbDataReader reader =
                objCommand.ExecuteReader(CommandBehavior.CloseConnection);
            while (reader.Read())
            {
                customerID.Add(reader.GetString(0));
                companyName.Add(reader.GetString(1));
            }
            reader.Close();
        }
    
        // Получение всех закрепленных за сотрудником заказов
        ArrayList ordersCustomerID = new ArrayList();
        void LoadOrders()
        {
            if (cbEmployees.SelectedIndex == -1)
                return;
    
            // Создаем объект соединения
            OleDbConnection objConnection =
                new OleDbConnection(ConnectionString("Northwind"));
            // Создаем объект команды
            OleDbCommand objCommand = new OleDbCommand(
                "SELECT CustomerID FROM Orders WHERE (EmployeeID = ?)",
                objConnection);
            objCommand.Parameters.Add(new OleDbParameter());
            objCommand.Parameters[0].Value = cbEmployees.SelectedValue.ToString();
    
            objConnection.Open();   // Открываем соединение
            OleDbDataReader reader = objCommand.ExecuteReader();// Читаем в DbDataReader
            if (reader.HasRows)
            {
                // Чистим список
                ordersCustomerID.Clear();
                while(reader.Read())
                {
                    ordersCustomerID.Add(reader["CustomerID"]);
                }
            }
            objConnection.Close();  // Закрываем соединение
        }
    }
}
