﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

// Дополнительные пространства имен
using System.Data.OleDb;
using System.Data.Common;
using System.Collections;
    
namespace WinForms4
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
    
            LoadCustomers();
        }
    
        private void txtCustomerID_KeyPress(object sender, KeyPressEventArgs e)
        {
            e.Handled = true;
        }
    
        private void txtCustomerID_KeyDown(object sender, KeyEventArgs e)
        {
            e.Handled = true;
        }
    
        // Строка соединения с абсолютным путем к БД, определяемым сборкой
        String ConnectionString(String fileName)
        {
            string JetEngineString = @"Provider=Microsoft.Jet.OLEDB.4.0;"
                + "Jet OLEDB:Engine Type=5;Data Source=";
            string pathToFile = Application.StartupPath.ToString() + "\\Data\\";
            return JetEngineString + pathToFile + fileName.Trim() + ".mdb";
        }
    
        DataTable tableCustomers;
        void LoadCustomers()
        {
            OleDbCommand selectCommand = new OleDbCommand();
            selectCommand.CommandText="SELECT * FROM Customers";
            selectCommand.Connection = new OleDbConnection(ConnectionString("Northwind"));
            selectCommand.CommandType = CommandType.Text;
            OleDbDataAdapter adapter = new OleDbDataAdapter(selectCommand);
    
            tableCustomers = new DataTable();// Создать таблицу
            try
            {
                // Заполнить таблицу
                adapter.Fill(tableCustomers);
                // Указать первичный ключ из одного столбца для использования метода Find()
                tableCustomers.PrimaryKey = 
                    new DataColumn[] { tableCustomers.Columns["CustomerID"] };
            }
            catch (OleDbException exc)
            {
                tableCustomers = null;
                MessageBox.Show(exc.Message, "Ошибка",
                    MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
            finally
            {
                selectCommand.Connection.Close();
            }
    
            // Связываем ComboBox с виртуальной таблицей
            cbCustomers.DataSource = tableCustomers;
            cbCustomers.DisplayMember = "CompanyName";
            cbCustomers.ValueMember = "CustomerID";
        }
    
        private void cbCustomers_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (tableCustomers == null)
                return; // При исключении выходить
    
            // Найти запись
            Object findValue = cbCustomers.SelectedValue;// Выделенное значение ValueMember
            DataRow row = tableCustomers.Rows.Find(findValue);
    
            // Заполнить текстовые поля
            if (row != null)
            {
                txtCustomerID.Text = row["CustomerID"].ToString();
                txtCompanyName.Text = row["CompanyName"].ToString();
                txtAddress.Text = row["Address"].ToString();
                txtCity.Text = row["City"].ToString();
                txtRegion.Text = row["Region"].ToString();
                txtPhone.Text = row["Phone"].ToString();
            }
        }
    }
}
