﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
    
// Дополнительные пространства имен
using System.Data.OleDb;
using System.Data.Common;
using System.Collections;
    
namespace WinForms5
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
    
            LoadTables();
        }
    
        //***********************************************************
        // Строка соединения с абсолютным путем к БД, определяемым сборкой
        // Не используем !!!!!! Заменили объектом-построителем 
        String ConnectionString(String fileName)
        {
            string JetEngineString = @"Provider=Microsoft.Jet.OLEDB.4.0;"
                + "Jet OLEDB:Engine Type=5;Data Source=";
            string pathToFile = Application.StartupPath.ToString() + "\\Data\\";
            return JetEngineString + pathToFile + fileName.Trim() + ".mdb";
        }
        //**********************************************************
    
        // Поле-ссылка на таблицу Orders
        DataTable tableOrders;
        void LoadTables()
        {
            // Используем построитель строки подключения 
            // для облегчения формирования оной!
            OleDbConnectionStringBuilder objConnectionStringBuilder =
                new OleDbConnectionStringBuilder();
            objConnectionStringBuilder.Provider = "Microsoft.Jet.OLEDB.4.0";
            objConnectionStringBuilder.DataSource =
                Application.StartupPath.ToString() + @"\Data\Northwind.mdb";
            objConnectionStringBuilder.PersistSecurityInfo = true;// Шифровать строку
    
            // Строка соединения с источником данных
            String strConnection = objConnectionStringBuilder.ToString();
            // Строка запроса 
            String strSQL = "SELECT EmployeeID, LTRIM(RTRIM(LastName)) + ', '"
                + "+ LTRIM(RTRIM(FirstName)) AS FullName FROM Employees";
    
            // Создаем поставщик данных для таблицы Employees
            OleDbDataAdapter adapter = new OleDbDataAdapter(strSQL, strConnection);
    
            // Создаем и заполняем виртуальную таблицу 
            DataTable tableEmployees = new DataTable();
            adapter.Fill(tableEmployees);
            tableEmployees.TableName = "Employees";
    
            // Сортируем в прямом порядке: "FullName" или "FullName ASC"
            // Сортировка в обратном порядке: "FullName DESC";
            tableEmployees.DefaultView.Sort = "FullName ASC";
    
            // Связываем ComboBox с виртуальной таблицей
            //cbEmployees.DataSource = tableEmployees; //Связать таблицу несортированной 
            // Связать через DataView сортированной

            cbEmployees.DataSource = tableEmployees.DefaultView;
            cbEmployees.DisplayMember = "FullName";
            cbEmployees.ValueMember = "EmployeeID";
            cbEmployees.SelectedIndex = 0;
   
            /* Всякие пробы..., жалко выбрасывать!!!
            OleDbCommandBuilder commandBuilder = new OleDbCommandBuilder(adapter);
            commandBuilder.RefreshSchema();// Обновить схему в адаптере
            */
    
            // Заполняем виртуальную таблицу Orders всеми записями
            OleDbCommand selectCommand = new OleDbCommand(
                "SELECT OrderID, EmployeeID, ShipAddress FROM Orders");
            selectCommand.Connection = new OleDbConnection(strConnection);
            adapter = new OleDbDataAdapter(selectCommand);
            tableOrders = new DataTable();
            adapter.Fill(tableOrders);
        }
    
        private void cbEmployees_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (tableOrders == null)
                return;
    
            // Выбираем строки по условию 
            String filterExpression = "EmployeeID = " + cbEmployees.SelectedValue;
            DataRow[] rows = tableOrders.Select(
                filterExpression,   // Выражение для фильтра
                "ShipAddress ASC");     // Поле сортировки по возрастанию
                // "ShipAddress DESC" - сортировка по убыванию!!!
            // Очищаем список
            lstOrders.Items.Clear();
            // Заполняем список
            foreach (DataRow row in rows)
            {
                lstOrders.Items.Add(
                    "(" + row["EmployeeID"] + ") "
                    + row["OrderID"].ToString()
                    + "\t" + row["ShipAddress"]);
            }
        }
    }
}
