﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
    
// Дополнительные пространства имен
using System.Data.OleDb;
using System.Data.Common;
using System.Collections;
    
namespace WinForms6
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
    
            LoadProducts();
        }
    
        // Строка соединения к БД с абсолютным путем, определяемым сборкой
        String ConnectionString()
        {
            // Используем построитель строки подключения 
            OleDbConnectionStringBuilder objConnectionStringBuilder =
                new OleDbConnectionStringBuilder();
            objConnectionStringBuilder.Provider = "Microsoft.Jet.OLEDB.4.0";
            objConnectionStringBuilder.DataSource =
                Application.StartupPath.ToString() + @"\Data\Northwind.mdb";
    
            return objConnectionStringBuilder.ToString();
        }
    
        void LoadProducts()
        {
            // Формируем поставщик 
            OleDbCommand selectCommand = new OleDbCommand();
            selectCommand.CommandText = 
                "SELECT ProductID, ProductName, UnitPrice AS Price FROM Products";
            selectCommand.Connection = new OleDbConnection(ConnectionString());
            selectCommand.CommandType = CommandType.Text;
            OleDbDataAdapter adapter = new OleDbDataAdapter(selectCommand);
            
            // Создаем объект таблицы
            DataTable tableProducts = new DataTable();  
          
            // Задаем тип столбца, подлежащего заполнению данными из БД
            // (ДО ЕГО ЗАПОЛНЕНИЯ!!!)
            tableProducts.Columns.Add("Price");
            tableProducts.Columns["Price"].DataType = typeof(System.Decimal);
    
            // Добавляем и настраиваем вычислимый столбец для величины наценки
            tableProducts.Columns.Add("Margin", typeof(System.Decimal));
            tableProducts.Columns[1].Expression = "Price * 0.086";
    
            // Добавляем  и настраиваем вычислимый столбец для потребительской цены
            DataColumn totalPrice = new DataColumn("Total Price");
            totalPrice.DataType = System.Type.GetType("System.Decimal");
            totalPrice.Expression = "Price + Margin";
            tableProducts.Columns.Add(totalPrice);
            
            // Заполняем таблицу
            adapter.Fill(tableProducts);
    
            // Связываем таблицу с элементом отображения
            dataGridView.DataSource = tableProducts;
    
            Object result = tableProducts.Compute("Sum(Margin)", null);
            MessageBox.Show(String.Format("Суммарная наценка на товар\n"
                + "(по курсу 30 рублей за доллар): {0:C}",// Спецификатор денежного формата
                Convert.ToDecimal(result) * 30.0m));
    
            result = tableProducts.Compute("Count(Price)", "Price < 10");
            MessageBox.Show(String.Format("Количество товара с ценой меньше 10$: {0} шт.", result));
        }
    }
}